Attribute VB_Name = "ColorConvert"
'Dieser Source stammt von http://www.vb-fun.de.
'Fr eventuelle Schden wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

'Farb-Reihenfolge Enumeration
Public Enum COLOR_SEQUENZ
    C_RGB = 1 'Die Farbreihenfolge ist RGB
    C_BGR = 2 'Die Farbreihenfolge ist BGR
End Enum
'16bit mode format Enumeration
Public Enum c16BIT
    Mode555 = 1 'Das 16bit Format ist 555
    Mode565 = 2 'Das 16bit Format ist 565
End Enum
Public RGBForm As COLOR_SEQUENZ
Public Mode16 As c16BIT
Public BitDepth As Integer 'Farbtiefe
Public GBitMask As Single 'Grn Bit Maske
Public RBitMask As Single 'Rot Bit Maske
Public BBitMask As Single 'Blau Bit Maske
'RGB-Farbanteile Benutzerdefinierter Datentyp
Public Type cRGB
    r As Byte
    g As Byte
    b As Byte
End Type

Public Sub GetColorMode(ddPS As DirectDrawSurface7)
    Dim ddsd As DDSURFACEDESC2
    
    'ber die PrimarySurface erhalten wir die Informationen
    'der Farben, der Farbtiefe usw.
    ddPS.GetSurfaceDesc ddsd
    
    With ddsd.ddpfPixelFormat
        BitDepth = .lRGBBitCount  'Auslesen der Farbtiefe
        'Farbreihenfolge prfen ... RGB oder BGR
        If .lRBitMask > .lBBitMask Then
            RGBForm = C_BGR
        Else
            RGBForm = C_RGB
        End If
        'Handelt es sich um 16bit Farben, dann mssen
        'wir den Modus feststellen. 555 oder 565
        'Die lGBitMask (Green Color Mask) ist &H7E0 beim
        '565-Modus und &H3E0 beim 555-Modus
        If BitDepth = 16 Then
            If .lGBitMask = &H7E0 Then
                Mode16 = Mode565 '565 Format
            Else
                Mode16 = Mode555 '555 Format
            End If
        End If
        'Auslesen der FarbBitmasken
        GBitMask = .lGBitMask
        RBitMask = .lRBitMask
        BBitMask = .lBBitMask
    End With
    
End Sub

Function To16bit(Color As cRGB) As Long
    Dim bsG As Single
    Dim bsR As Single
    Dim bsB As Single
    Dim cr As cRGB
    
    cr = Color
    'Wir scheiden 3 bits vom Rot
    'Dazu benutzen wir das "\" symbol
    '(integer division) anstatt "/" welches
    'keinen Integer-Wert zurckliefert was
    'wiederum falsche Ergebnise bringen wrde
    
    cr.r = cr.r \ &H8
    
    'Prfen welchen 16bit Modus wir haben
    'bei 555 schneiden wir 3 bits, bei 565 2 bits
    If Mode16 = Mode555 Then
        cr.g = cr.g \ &H8
    Else
        cr.g = cr.g \ &H4
    End If
    
    '3 bits von Blau abschneiden
    cr.b = cr.b \ &H8
    
    'bsR, bsG und bsB beinhalten die Anzahl
    'abzuschneidender Bits ("shifting")
    'die Grne shifting-Variable ist bei
    'Modus 555 und 565 gleich
    bsG = &H20
    If Mode16 = Mode555 Then
        If RGBForm = C_BGR Then
        'ist die Reihenfolge BGR hat Rot den
        'hchsten und Blau den niedrigsten Wert
        'im 555 Modus mssen 10 bits abgeschnitten
        'werden um den Rotanteil zu erhalten
            bsR = &H400
            bsB = 1
        ElseIf RGBForm = C_RGB Then
        'bei RGB genau umgekehrt
            bsB = &H400
            bsR = 1
        End If
    ElseIf Mode16 = Mode565 Then
        If RGBForm = C_BGR Then
        'im 565 Modus sind es 11 bits
            bsR = &H800
            bsB = 1
        ElseIf RGBForm = C_RGB Then
            bsB = &H800
            bsR = 1
        End If
    End If
    
    'mit dem logischen Operator OR kombinieren
    'wir die einzelnen Farben zu einem Farbwert
    To16bit = cr.r * bsR Or cr.g * bsG Or cr.b * bsB
    
End Function

Public Function GetRGB16(Color As Long) As cRGB
    Dim bsG As Single
    Dim bsR As Single
    Dim bsB As Single
    
    'bsR, bsG und bsB beinhalten die Anzahl
    'abzuschneidender Bits ("shifting")
    'die Grne shifting-Variable ist bei Modus 555 und 565 gleich
    bsG = &H20
    If Mode16 = Mode555 Then
        If RGBForm = C_BGR Then
        'ist die Reihenfolge BGR hat Rot den
        'hchsten und Blau den niedrigsten Wert
        'im 555 Modus mssen 10 bits abgeschnitten
        'werden um den Rotanteil zu erhalten
            bsR = &H400
            bsB = 1
        ElseIf RGBForm = C_RGB Then
        'bei RGB genau umgekehrt
            bsB = &H400
            bsR = 1
        End If
    ElseIf Mode16 = Mode565 Then
        If RGBForm = C_BGR Then
        'im 565 Modus sind es 11 bits
            bsR = &H800
            bsB = 1
        ElseIf RGBForm = C_RGB Then
            bsB = &H800
            bsR = 1
        End If
    End If
    'Um die einzelnen Farbanteile einer 16bit-Farbe
    'zu erhalten, wird der Farbwert mit "And" dem
    'Bitmaske addiert und durch
    'die shifting-Variable dividiert.
    With GetRGB16
        .r = (Color And RBitMask) / bsR
        .g = (Color And GBitMask) / bsG
        .b = (Color And BBitMask) / bsB
    End With
    
End Function

Public Function Get16BitColor(Color As cRGB) As Long
    Dim bsG As Single
    Dim bsR As Single
    Dim bsB As Single
    
    'bsR, bsG und bsB beinhalten die Anzahl auszuschneidender Bits ("shifting")
    
    'die Grne shifting-Variable ist bei Modus 555 und 565 gleich
    bsG = &H20
    If Mode16 = Mode555 Then
        If RGBForm = C_BGR Then
        'ist die Reihenfolge BGR hat Rot den hchsten und Blau den niedrigsten Wert
        'im 555 Modus mssen 10 bits ausgeschnitten werden um den Rotanteil zu erhalten
            bsR = &H400
            bsB = 1
        ElseIf RGBForm = C_RGB Then
        'bei RGB genau umgekehrt
            bsB = &H400
            bsR = 1
        End If
    ElseIf Mode16 = Mode565 Then
        If RGBForm = C_BGR Then
        'im 565 Modus sind es 11 bits
            bsR = &H800
            bsB = 1
        ElseIf RGBForm = C_RGB Then
            bsB = &H800
            bsR = 1
        End If
    End If
    
    'mit dem logischen Operator OR kombinieren wir die einzelnen
    'Farben zu einem Farbwert
    Get16BitColor = Color.r * bsR Or Color.g * bsG Or Color.b * bsB

End Function

'Public Function GetRGB24(Color As Long) As cRGB
'    Dim bsG As Single
'    Dim bsR As Single
'    Dim bsB As Single
'    Dim Rmask As Long
'    Dim Gmask As Long
'    Dim Bmask As Long
'
'    'Wenn wir im 16bit Modus sind knnen wir
'    'die 24bit Farbmasken nicht auslesen.
'    'Sie mssen daher per Hand deklariert werden.
'    bsR = 1
'    bsG = &H100
'    bsB = &H10000
'
'    Rmask = &HFF
'    Gmask = &HFF00
'    Bmask = &HFF0000
'
'    With GetRGB24
'        .r = (Color And Rmask) / bsR
'        .g = (Color And Gmask) / bsG
'        .b = (Color And Bmask) / bsB
'    End With
'
'End Function
'
