Attribute VB_Name = "DDrawModule"
'Dieser Source stammt von http://www.vb-fun.de.
'Fr eventuelle Schden wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Public DX As New DirectX7
Public DDRAW As DirectDraw7
Public DSOUND As DirectSound
Public Primary As DirectDrawSurface7
Public Backbuffer As DirectDrawSurface7
Public Background As DirectDrawSurface7
Public ExplodeSound(1 To 3) As DirectSoundBuffer
Public RocketSound(1 To 3) As DirectSoundBuffer

'DirectX und DirectDraw initialisieren
Function Init(hwnd As Long) As Boolean
    On Error Resume Next
    Dim SurfDesc As DDSURFACEDESC2
    Dim Caps As DDSCAPS2
    Dim i As Integer
    Dim BufferDesc As DSBUFFERDESC
    Dim WavFormat As WAVEFORMATEX
    ' DirectDraw erstellen
    Set DDRAW = DX.DirectDrawCreate("")
    ' Cooperative Level und Screen-Gre setzen
    DDRAW.SetCooperativeLevel hwnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWREBOOT
    DDRAW.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT
    ' Primary Surface erstellen
    With SurfDesc
        .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
        .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
        .lBackBufferCount = 1
    End With
    Set Primary = DDRAW.CreateSurface(SurfDesc)
    ' BackBuffer hinzufgen
    Caps.lCaps = DDSCAPS_BACKBUFFER
    Set Backbuffer = Primary.GetAttachedSurface(Caps)
    ' Hintergrundbild laden
    SurfDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    SurfDesc.lFlags = DDSD_CAPS
    SurfDesc.lWidth = 640
    SurfDesc.lHeight = 480
    Dim temppic As IPictureDisp
    Set temppic = LoadPicture(App.Path & "\background.jpg")
    SavePicture temppic, App.Path & "\background.bmp"
    Set Background = DDRAW.CreateSurfaceFromFile(App.Path & "\background.bmp", SurfDesc)
    ' DirectSound erstellen
    Set DSOUND = DX.DirectSoundCreate("")
    ' DirectSound Cooperative Level setzen
    DSOUND.SetCooperativeLevel hwnd, DSSCL_PRIORITY
    ' Sounds laden
    For i = 1 To 3
        Set ExplodeSound(i) = DSOUND.CreateSoundBufferFromFile(App.Path & "\explode" & i & ".wav", BufferDesc, WavFormat)
        Set RocketSound(i) = DSOUND.CreateSoundBufferFromFile(App.Path & "\rocket" & i & ".wav", BufferDesc, WavFormat)
    Next
    ' Fehlerbehandlung
    If Err.Number = DD_OK Then Init = True
    ' Farbtiefe und Farbreihenfolge feststellen
    GetColorMode Primary
End Function

'DirectX schlieen und bereinigen
Function CleanUp(hwnd As Long) As Boolean
    On Error Resume Next
    ' Screen-Einstellung wieder herstellen
    DDRAW.RestoreDisplayMode
    DDRAW.SetCooperativeLevel hwnd, DDSCL_NORMAL
    ' Surfaces lschen
    Set Backbuffer = Nothing
    Set Primary = Nothing
    ' Sounds lschen
    Dim i As Integer
    For i = 1 To 3
        Set ExplodeSound(i) = Nothing
        Set RocketSound(i) = Nothing
    Next
    ' DirectX, DirectDraw und DirectSound schlieen
    Set DSOUND = Nothing
    Set DDRAW = Nothing
    Set DX = Nothing
    ' Fehlerbehandlung
    If Err.Number = DD_OK Then CleanUp = True
End Function

